import {NgModule, ModuleWithProviders} from '@angular/core';
import {CommonModule} from "@angular/common";
import {FormsModule} from "@angular/forms";
import {SelectComponent} from "./src/component";
import {InnerTemplateDirective} from "./src/directive";
import {SelectService} from "./src/service";

export * from './src/component';
export * from './src/common';
export * from './src/directive';
export * from './src/service';

@NgModule({
  imports     : [
    CommonModule,
    FormsModule,
  ],
  exports     : [
    InnerTemplateDirective,
    SelectComponent,
  ],
  declarations: [
    InnerTemplateDirective,
    SelectComponent
  ]
})
export class Ng2Select2Bootstrap {
  static forRoot(): ModuleWithProviders {
    return <ModuleWithProviders>{
      ngModule: Ng2Select2Bootstrap,
      providers: [SelectService]
    };
  }
}